<?php
/*********************************************************************************
*                              DBWrapper
*  This is wrapper class for connecting with different databases. Currently it
*  works for MySQL and Oracle, but you can add as many databases, as you want.
*  The constructor of the class receives the database name as an argument. Usually
*  it should be written as is, i.e. "MySQL" or "Oracle". The class defaults
*  to MySQL
**********************************************************************************/
class DBWrapper
{   

    var $Server;
    var $DB;
    var $User;
    var $Password;
    var $Error;

    function DBWrapper($server,$db,$user,$pass,$DBname="MySQL")
    {
        if(!defined('DATABASE_NAME')||$DBname!=DATABASE_NAME)
    	{
    	  define('DATABASE_NAME',$DBname);
    	}

        $this->Server =$server;
        $this->DB = $db;
        $this->User = $user;
        $this->Password = $pass;



        switch (DATABASE_NAME)
        {
           case "MySQL":

           mysql_connect($this->Server, $this->User, $this->Password) or
					die("Error: could not connect to the database.");

           mysql_select_db($this->DB) or
					die("Error: could not select database.");
	   break;

	   case "Oracle":
	   //implement Oracle connections here
	   ora_logon($this->User, $this->Password) or
                                        die("Error: could not connect to the database.");
           $cursor=ora_parse ("USE ".$this->DB)or
					die("Error: could not select database.");
           ora_exec($cursor)or
					die("Error: could not select database.");
	   break;
        }
    }

    /*!
      Execute a query on the global SQL database link.  If it returns an error,
      the script is halted and the attempted SQL query and SQL error message are printed.
    */
    function &query($sql, $Destroy = false)
    {
        switch (DATABASE_NAME)
        {
           case "MySQL":
           $result = mysql_query( $sql );

           if ($Destroy)
           {
               	mysql_free_result($result);
        	return (true);
           }

           break;

           case "Oracle":
           //implement Oracle query here
           $cursor=ora_parse ("USE ".$this->DB);

           ora_exec($cursor);

           break;
        }

        if ( $result )
        {
            return $result;
        }
        else
        {
            switch (DATABASE_NAME){
               case "MySQL":
               $error=mysql_error();
               break;

               case "Oracle":
               ora_error($cursor);
               break;
            }

            $this->Error = "<code>" . htmlentities( $sql ) . "</code><br>\n<b>" . htmlentities($error) . "</b>\n" ;
            print( $this->Error );
            exit();
            return false;
        }
    }

    /*!
      Executes a SELECT query that returns multiple rows and puts the results into the passed
      array as an indexed associative array.  The array is cleared first.  The results start with
      the array start at 0, and the number of results can be found with the count() function.
    */
    function array_query($sql)
    {
        $array = array();
        $result=mysql_query($sql);
        while($row=@mysql_fetch_array($result))
        {
           //echo $row;
           array_push($array,$row);
        }
        return $array;
    }

    /*!
      Same as array_query() but expects to receive 1 row only (no array), no more no less.
    */
    function single_query( $sql )
    {
         switch (DATABASE_NAME)
         {
               case "MySQL":
               //die($sql);
               $result=mysql_query($sql);// or die(mysql_error());
               if($result) $row=mysql_fetch_array($result);
               break;

               case "Oracle":
               //to do
               break;
            }
    
       return $row;
    }

    /*!
      Same as single_query() but returns only one value directly, not as an array
    */
	function one_query($sql)
		{
        $array = array();
        $ret = $this->array_query_append( $array, $sql, 1, 1 );
        $row = $array[0];
        return $row[0];
		}

    /*!
      Differs from the above function only by not creating av empty array,
      but simply appends to the array passed as an argument.
     */
    function array_query_append( &$array, $sql, $min = 0, $max = -1 )
    {
        $result =& $this->query( $sql );

        if ( $result == false )
        {
            print( $this->Error );
            return false;
        }

        $offset = count( $array );

        if ( mysql_num_rows( $result ) > 0 )
        {
            for($eh = 0; $eh < mysql_num_rows($result); $eh++)
                $array[$eh + $offset] =& mysql_fetch_array($result);
        }

        if ( count( $array ) < $min )
        {
            $this->Error = "<code>" . htmlentities( $sql ) . "</code><br>\n<b>" .
                                      htmlentities( "Received " . count( $array ) . " rows, minimum is $min" ) . "</b>\n" ;
        }
        if ( $max >= 0 )
        {
            if ( count( $array ) > $max )
            {
                $this->Error = "<code>" . htmlentities( $sql ) . "</code><br>\n<b>" .
                                          htmlentities( "Received " . count( $array ) . " rows, maximum is $max" ) . "</b>\n" ;
            }
        }
				mysql_free_result($result);
    }

    /*!
      Returns the last error message.
    */
    function error()
    {
        return $this->Error;
    }

    /*!
      Returns the ID of the last inserted row.
    */
    function insertID()
    {
    	switch (DATABASE_NAME)
    	{
    	   case "MySQL":
	   return mysql_insert_id();
	   break;

	   case "Oracle":
	   //implement Oracle case here
	   break;
	}
    }

    /*!
      \static

      Closes the database connection.
    */
    function close()
    {
        switch (DATABSE_NAME)
        {
           case "MySQL":
           mysql_close();
           break;

           case "Oracle":
           //implement Oracle here
           break;
        }
    }
    
    function q($q)
    {
       return $this->query($q);
   }
   
   function sq($q)
   {
      return $this->single_query($q);
   }
   
   function aq($q)
   {
      return $this->array_query($q);
   }
   
   function oq($q)
   {
      return $this->one_query($q);
   }
}
?>
